/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni 8B ... jednorozmerne staticke pole
*/
#include<iostream>
using namespace std;

#define N 10  // makro (symbolicka promenna)

/* Funkce, jejimz parametrem je pole  */
int prvniPrvek1(int *a)
{
	return a[0];
}

/* Funkce, jejimz parametrem je staticke pole  */
int prvniPrvek(int a[])
{
	return a[0];
}

/* Funkce, ktera 'neprinasobi' k promenne a hodnotu x   */
void neprinasob(double a, double x)
{
	a *= x;
}

/* Funkce, ktera vynasobi vektor ulozeny v poli a delky n hodnotou x  */
void prinasob(double *a, int n, double x)
{
	for (int i = 0; i < n; i++)
	{
		a[i] *= x;
	}
}

/* Funkce, ktera vrati index maximalniho prvku
	v poli a delky n */
int indexMaxima(const double *a, int n)
{
	int im = 0;
	for (int i = 1; i < n; i++)
	{
		if (a[i] > a[im])
			im = i;
	}
	return im;
}

int main()
{
	/* Ukazka chybne napsaneho kodu, ktery se zacykli (prepisujeme si promennou i pod rukama)
	{
		int i;
		int a[5] = {};
		int b[10] = { 8,7,6,5,4,9 };
		int c[10] = {};

		for (i = 0; i < 5; i++)
			cin >> a[i];
		for (i = 0; i < 10; i++)
			a[i] = b[i];
		cout << a[0];
	} */
	{
		// deklarace a inicializace statickeho pole:
		int a[10];                 // neinicializovane pole delky 10
		int a1[5] = { 1,2,3,4,5 }; // inicializovane pole delky 5 
		int a2[] =  { 1,1,1,1,1 }; // delka pole podle poctu prvku 
		int a3[5] = { 3,4,3 };     // zbyle prvky budou inicializovane na 0
		int a4[5] = {};            // vsechny prvky budou inicializovane na 0

		// delka pole (=pocet prvku) musi byt konstantni vyraz: 
		const int n = 4;
		int a5[n];
		int a6[N];

		// pristup k prvkum pole, indexace
		int y = a1[0];
		a1[0] = 45 + a1[1];
	    cout << a1[0] << endl;
		for (int i = 0; i < 10; i++)
			a[i] = -i;
		
		// kopirovani prvku pole
		for (int i = 0; i < 5; i++)
			a[i] = a1[i];

		// vypis pole na jeden radek
		for (int i = 0; i < 5; i++)
			cout << a1[i] << ' ';
		cout << endl;
		
		// nebezpeci preteceni:
		/*
		for (int i = 0; i < 10; i++)
			a1[i] = 7;
		for (int i = 0; i < 10; i++)
			cout << a1[i] << ' ';
		cout << endl;
				*/

		// volani funkce s parametrem typu pole:
		y = prvniPrvek(a3);
		cout << prvniPrvek(a3) << endl;

		// promenna x typu double se funkci predava tzv. hodnotou (hodnota x s uvnitr funkce nezmeni, predava se jeji kopie)
		double x = 4;
		neprinasob(x, 0.5);
		cout << "hodnota x je stale " << x << endl;

		// promenna b typu double[] se funkci predava tzv. odkazem (hodnoty ulozene v poli b muzeme uvnitr funkce zmenit)
		double b[5] = { 4, -4.5, 0, 1, -2 };
		prinasob(b, 5, 0.5);

		for (int i = 0; i < 5; i++)
			cout << b[i] << " ";
		cout << endl;

		int im = indexMaxima(b, 5);
		cout << "maximum pole je na indexu " << im << " a ";
		cout << "jeho hodnota je " << b[im] << endl;

	}
	return 0;
}